package mana

// region default options //////////////////////////////////////////////////////////////////////////////////////////////

var DEFAULT_OPTIONS = &CalculatorOptions{
	ManaScaleFactor: 1,
}

// endregion ///////////////////////////////////////////////////////////////////////////////////////////////////////////

// region calculator options ///////////////////////////////////////////////////////////////////////////////////////////

func ManaScaleFactor(manaScaleFactor float64) CalculatorOption {
	return func(args *CalculatorOptions) {
		args.ManaScaleFactor = manaScaleFactor
	}
}

// endregion ///////////////////////////////////////////////////////////////////////////////////////////////////////////

// region type definitions /////////////////////////////////////////////////////////////////////////////////////////////

type CalculatorOptions struct {
	ManaScaleFactor float64
}

func (options CalculatorOptions) Override(optionalOptions ...CalculatorOption) *CalculatorOptions {
	result := &options
	for _, option := range optionalOptions {
		option(result)
	}

	return result
}

type CalculatorOption func(*CalculatorOptions)

// endregion ///////////////////////////////////////////////////////////////////////////////////////////////////////////
